#pragma once

#include "DialogManager.h"
#include "RecvMemoDlg.h"

class ReceivedNoteManager : public DialogManager,
	private IGTWASActorEvent
{
public:
	ReceivedNoteManager(void);
	~ReceivedNoteManager(void);

	void WasRegister() 
	{
		g_pMessengerActor->GetWASActor()->RegisterObserver(this);
	}

	bool MakeMemoRecvDlg(UINT64 lMemoID);
	bool MakeMemoRecvDlg(UINT64 noteID, const NoteInfo& noteInfo, bool flashEffect= true);
	void SetDlgRestore(UINT64 lMemoID);	
	void SetMaxDlg(int nMaxCount){m_nMaxDlgCount= nMaxCount;}

	int DlgSpaceCount();

	void SetViewLanguagePack();

	virtual void Remove(CDialog* pDialog);

protected:
	virtual bool	OnGTWASActor_ResponseNoteSetReadStatus(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode);
	virtual bool	OnGTWASActor_ResponseDeleteNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bResult);


private:
	virtual void SetReadOnly(BOOL bStatus, CObject* pObject);

	CRecvMemoDlg * GetReceivedNoteDlg(UINT64 lMemoId);

	int			 m_nMaxDlgCount;
	sqlite3		*m_pSQLite;

public:
	int InitSqlite(void);
	int CloseSqlite(void);
	int RestoreRecvNote(void);
	int DeleteRecvNoteFromSqlite(unsigned long noteID);
	int DeleteAllRecvNoteFromSqlite();
	int InsertRecvNoteToSqlite(unsigned long noteID);
	int InsertAllRecvNoteToSqlite();
};
